/*
 * fqwriter.cpp
 *
 *  Created on: Mar 15, 2016
 *      Author: vlegrand
 *      Here gather functions to write filtered fastq records to output files
 */

#include <map>
#include "srp.h"
#include "FqBaseBackend.h"

//#define DEBUG
#ifdef DEBUG
#include <iostream>
using namespace std;
#endif


// TODO this looks a little bit like getDnaStr in read_utils.cpp. Some refactoring could be useful. Think about
// classes to encapsulate that without decreasing perfs.
void writeFilteredFastq(FqBaseBackend* map_id_backend[],int nb_be, const srp& io_sr){
    srp::const_reverse_iterator it;
    i_dim::const_iterator it_offs;
    k_dim::const_iterator it_struct;

    unsigned char f_id1;
    unsigned char f_id2;
    unsigned char fid_stored;

    // 1rst step, open files before fetching/writing reads from/to them
    int i;
    for (i=0;i<nb_be;i++){
         map_id_backend[i]->openInputFile();
         map_id_backend[i]->openOutputFile();
    }

    for (it=io_sr.rbegin(); it!=io_sr.rend(); ++it) {
        for (it_offs=it->second.begin();it_offs!=it->second.end();it_offs++) {
            unsigned long j=it_offs->first;
            for (it_struct=it_offs->second.begin();it_struct!=it_offs->second.end();it_struct++) {
                if (it_struct->fileid) {
                    fid_stored=it_struct->fileid;
                    f_id1=fid_stored >>4;
                    f_id2=fid_stored &mask_fid;
                    unsigned long offset1=j*UINT_MAX+it_struct->read_a1;
#ifdef DEBUG
     cout<<"going to output record with: j="<<j<<"read_a1="<<it_struct->read_a1<<endl;
     cout<<"j*UINT_MAX+it_struct->read_a1 = "<<j*UINT_MAX+it_struct->read_a1<<endl;
     cout<<"offset1="<<offset1<<endl;
     cout<<"f_id1-1="<<f_id1-1<<endl;
#endif
                    FqBaseBackend * be=map_id_backend[f_id1-1];
                    be->writeToOutput(offset1);
                    if (f_id2!=0) { // case of PE reads.
                        unsigned long offset2=it_struct->read_a2+offset1;
#ifdef DEBUG
    cout<<"f_id2-1="<<f_id2-1<<endl;
    cout<<"offset2="<<offset2<<endl;
#endif
                        map_id_backend[f_id2-1]->writeToOutput(offset2);
                    }
                }
            }
        }
    }

    // last step, close files.
    for (i=0;i<nb_be;i++){
         map_id_backend[i]->closeInputFile();
         map_id_backend[i]->closeOutputFile();
    }
}




